unit MainUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, Buttons, ExtCtrls;

{ Konstanty }
const MaxPanel = 3; { Maximalni index panelu klaves ovladani pro jednoho hrace }
const TotPanels = MaxPanel + 1; { Celkovy pocet panelu pro jednoho hrace }
const MaxKeyNameString = 15; { Delka pole na ulozeni jmena klavesy -1 }
const MaxHS = 4; { Pocet polozek v high score -1 }
const MaxHSNameString = 3; { Delka pole na ulozeni jmena v high score -1 }

{ Barvy hadu }
const Blue = 0;
const Yellow = 1;
const Green = 2;
const Red = 3;

{ Maximalni index barvy a jejich celkovy pocet }
const MaxColor = 3;
const TotColors = MaxColor + 1;

{ Identifikatory (cisla) panelu pro jednoho hrace, ale i cisla
  absolutnich (ty odpovidaji parametrum bDirection v celem programu)/relativnich
  smeru pohybu. }
const GoUp = 0;
const TurnLeft = 0;
const GoDown = 1;
const TurnRight = 1;
const GoLeft = 2;
const GoRight = 3;

{ Typy }
type
  { Rekord s prvky interface pro jednoho hrace }
  TNibbleInterface = record
    CheckBox: ^TCheckBox;
    KeySpeedButton,
    HumSpeedButton,
    CompSpeedButton: ^TSpeedButton;
    IQTrackBar: ^TTrackBar;
    Panels: array[0..MaxPanel] of ^TPanel;
  end;

  { Rekord pro ulozeni nastaveni jednoho hrace }
  TNibbleSettings = record
    Checked, { Jestli je u hrace zaskrtnut CheckBox }
    IsHuman, { Jestli hraje to clovek }
    UsesTwoKeys: Boolean; { Jestli hraje s dvema klavesama }
    KeyNames: array[0..MaxPanel, 0..MaxKeyNameString] of Char; { Jmena klaves }
    IQ: Byte; { Pocitacova inteligence }
  end;

  { Ukazatele na labely High Score }
  THighScoreLabels = record
    Score: ^TLabel;
    Name: ^TLabel;
  end;

  { Typ pro ulozeni Virtual Key Codes klaves ovladani pro vsechny hrace }
  TKeySettings = array[0..MaxColor, 0..MaxPanel] of BYTE;

  { Rekord obsahujici nastaveni klaves, HighScore, apod. Slouzi k jejich
    ulozeni do souboru. }
  TDataToSave = record
    { Nastaveni jednotlivych hracu }
    NibbleSettings: array[0..MaxColor] of TNibbleSettings;
    { Kody klaves ovladani }
    KeySettings: TKeySettings;
    { Pozice TrackBaru }
    GameSpeed: Byte;
    { Prehrani zvuku }
    PlaySound: Boolean;
    { High score }
    HighScoreNames: array[0..MaxHS,0..MaxHSNameString] of Char;
    HighScores: array[0..MaxHS] of Longint;
  end;

  TMainForm = class(TForm)
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    BlueCheckBox: TCheckBox;
    YellowCheckBox: TCheckBox;
    GreenCheckBox: TCheckBox;
    RedCheckBox: TCheckBox;
    Label6: TLabel;
    GameSpeedTrackBar: TTrackBar;
    BlueUpPanel: TPanel;
    BlueDownPanel: TPanel;
    BlueLeftPanel: TPanel;
    BlueRightPanel: TPanel;
    YellowUpPanel: TPanel;
    YellowDownPanel: TPanel;
    YellowLeftPanel: TPanel;
    YellowRightPanel: TPanel;
    GreenUpPanel: TPanel;
    GreenDownPanel: TPanel;
    GreenLeftPanel: TPanel;
    GreenRightPanel: TPanel;
    MainMenuImage: TImage;
    RedUpPanel: TPanel;
    RedDownPanel: TPanel;
    RedLeftPanel: TPanel;
    RedRightPanel: TPanel;
    HelpButton: TButton;
    StartGameButton: TButton;
    QuitButton: TButton;
    Label8: TLabel;
    HS1NameLabel: TLabel;
    HS1ScoreLabel: TLabel;
    HS2NameLabel: TLabel;
    HS4NameLabel: TLabel;
    HS3NameLabel: TLabel;
    HS5NameLabel: TLabel;
    HS2ScoreLabel: TLabel;
    HS3ScoreLabel: TLabel;
    HS4ScoreLabel: TLabel;
    HS5ScoreLabel: TLabel;
    BlueHumSpeedButton: TSpeedButton;
    BlueCompSpeedButton: TSpeedButton;
    YellowHumSpeedButton: TSpeedButton;
    GreenCompSpeedButton: TSpeedButton;
    GreenHumSpeedButton: TSpeedButton;
    YellowCompSpeedButton: TSpeedButton;
    RedCompSpeedButton: TSpeedButton;
    RedHumSpeedButton: TSpeedButton;
    SoundCheckBox: TCheckBox;
    BlueKeySpeedButton: TSpeedButton;
    YellowKeySpeedButton: TSpeedButton;
    GreenKeySpeedButton: TSpeedButton;
    RedKeySpeedButton: TSpeedButton;
    BlueIQTrackBar: TTrackBar;
    YellowIQTrackBar: TTrackBar;
    GreenIQTrackBar: TTrackBar;
    RedIQTrackBar: TTrackBar;
    procedure QuitButtonClick(Sender: TObject);
    procedure BlueUpPanelClick(Sender: TObject);
    procedure BlueDownPanelClick(Sender: TObject);
    procedure BlueLeftPanelClick(Sender: TObject);
    procedure BlueRightPanelClick(Sender: TObject);
    procedure YellowUpPanelClick(Sender: TObject);
    procedure YellowDownPanelClick(Sender: TObject);
    procedure YellowLeftPanelClick(Sender: TObject);
    procedure YellowRightPanelClick(Sender: TObject);
    procedure GreenUpPanelClick(Sender: TObject);
    procedure GreenDownPanelClick(Sender: TObject);
    procedure GreenLeftPanelClick(Sender: TObject);
    procedure GreenRightPanelClick(Sender: TObject);
    procedure RedUpPanelClick(Sender: TObject);
    procedure RedDownPanelClick(Sender: TObject);
    procedure RedLeftPanelClick(Sender: TObject);
    procedure RedRightPanelClick(Sender: TObject);
    procedure BlueCheckBoxClick(Sender: TObject);
    procedure YellowCheckBoxClick(Sender: TObject);
    procedure GreenCheckBoxClick(Sender: TObject);
    procedure RedCheckBoxClick(Sender: TObject);
    procedure HelpButtonClick(Sender: TObject);
    procedure StartGameButtonClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure BlueKeySpeedButtonClick(Sender: TObject);
    procedure YellowKeySpeedButtonClick(Sender: TObject);
    procedure GreenKeySpeedButtonClick(Sender: TObject);
    procedure RedKeySpeedButtonClick(Sender: TObject);
  private
    { Promenne }
    DataToSave: TDataToSave; { Data k ulozeni }
    SaveFileName: string;    { Jmeno souboru pro ukladani vcetne cesty. }

    { Private declarations }
    procedure LoadConfiguration;
    procedure SaveConfiguration;
    procedure SetKey(bColor, bPanel: Byte);
    procedure CheckBoxClick(bColor: Byte);
    procedure KeySpeedButtonClick(bColor: Byte);
  public

    { Public declarations }
    NibbleInterface: array[0..MaxColor] of TNibbleInterface; { Prvky interface pro vsechny hrace }
    KeySettings: TKeySettings; { Toto pole obsahuje Virtual Key Codes klaves ovladani (pro kazdy panel).  }
    HighScoreLabels: array[0..MaxHS] of THighScoreLabels; { Ukazatele na polozky High Score }

end;

var
  MainForm: TMainForm;

implementation

uses KeybUnit, GameUnit, HelpUnit;

{$R *.DFM}

{ Tato procedura nastava pri vytvoreni formy, jen vytvori jmeno ukladaciho
  souboru, ulozi ukazatele na prvky interface a zavola proceduru LoadConfiguration. }
procedure TMainForm.FormCreate(Sender: TObject);
begin
  { Jmeno ukladaciho souboru se vytvori z prvniho parametru na prikazove
    radce, ten obsahuje jmeno a plnou cestu k 'Nibbles.exe', tedy jen
    zamenime 'exe' za 'dat'. }
  SaveFileName := ChangeFileExt(ParamStr(0), '.DAT');

  { Ulozime si ukazatele na prvky interface jednotlivych hadu }
  NibbleInterface[Blue].Panels[GoUp] := @BlueUpPanel;
  NibbleInterface[Blue].Panels[GoDown] := @BlueDownPanel;
  NibbleInterface[Blue].Panels[GoLeft] := @BlueLeftPanel;
  NibbleInterface[Blue].Panels[GoRight] := @BlueRightPanel;
  NibbleInterface[Blue].CheckBox := @BlueCheckBox;
  NibbleInterface[Blue].KeySpeedButton := @BlueKeySpeedButton;
  NibbleInterface[Blue].HumSpeedButton := @BlueHumSpeedButton;
  NibbleInterface[Blue].CompSpeedButton := @BlueCompSpeedButton;
  NibbleInterface[Blue].IQTrackBar := @BlueIQTrackBar;

  NibbleInterface[Yellow].Panels[GoUp] := @YellowUpPanel;
  NibbleInterface[Yellow].Panels[GoDown] := @YellowDownPanel;
  NibbleInterface[Yellow].Panels[GoLeft] := @YellowLeftPanel;
  NibbleInterface[Yellow].Panels[GoRight] := @YellowRightPanel;
  NibbleInterface[Yellow].CheckBox := @YellowCheckBox;
  NibbleInterface[Yellow].KeySpeedButton := @YellowKeySpeedButton;
  NibbleInterface[Yellow].HumSpeedButton := @YellowHumSpeedButton;
  NibbleInterface[Yellow].CompSpeedButton := @YellowCompSpeedButton;
  NibbleInterface[Yellow].IQTrackBar := @YellowIQTrackBar;

  NibbleInterface[Green].Panels[GoUp] := @GreenUpPanel;
  NibbleInterface[Green].Panels[GoDown] := @GreenDownPanel;
  NibbleInterface[Green].Panels[GoLeft] := @GreenLeftPanel;
  NibbleInterface[Green].Panels[GoRight] := @GreenRightPanel;
  NibbleInterface[Green].CheckBox := @GreenCheckBox;
  NibbleInterface[Green].KeySpeedButton := @GreenKeySpeedButton;
  NibbleInterface[Green].HumSpeedButton := @GreenHumSpeedButton;
  NibbleInterface[Green].CompSpeedButton := @GreenCompSpeedButton;
  NibbleInterface[Green].IQTrackBar := @GreenIQTrackBar;

  NibbleInterface[Red].Panels[GoUp] := @RedUpPanel;
  NibbleInterface[Red].Panels[GoDown] := @RedDownPanel;
  NibbleInterface[Red].Panels[GoLeft] := @RedLeftPanel;
  NibbleInterface[Red].Panels[GoRight] := @RedRightPanel;
  NibbleInterface[Red].CheckBox := @RedCheckBox;
  NibbleInterface[Red].KeySpeedButton := @RedKeySpeedButton;
  NibbleInterface[Red].HumSpeedButton := @RedHumSpeedButton;
  NibbleInterface[Red].CompSpeedButton := @RedCompSpeedButton;
  NibbleInterface[Red].IQTrackBar := @RedIQTrackBar;

  { Ulozime ukazatele na High Score }
  HighScoreLabels[0].Name := @HS1NameLabel;
  HighScoreLabels[0].Score := @HS1ScoreLabel;
  HighScoreLabels[1].Name := @HS2NameLabel;
  HighScoreLabels[1].Score := @HS2ScoreLabel;
  HighScoreLabels[2].Name := @HS3NameLabel;
  HighScoreLabels[2].Score := @HS3ScoreLabel;
  HighScoreLabels[3].Name := @HS4NameLabel;
  HighScoreLabels[3].Score := @HS4ScoreLabel;
  HighScoreLabels[4].Name := @HS5NameLabel;
  HighScoreLabels[4].Score := @HS5ScoreLabel;

  { A nahrajeme nastaveni ze souboru }
  LoadConfiguration;
end;


{ Pri zavreni formy ulozime konfiguraci }
procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  SaveConfiguration;
end;


{ Tato procedura nahraje nastaveni ovladani, tabulku HighScore apod. ze souboru
  Nibbles.dat (musi byt ve stejnem adresari jako Nibbles.exe), pokud tento soubor
  neexistuje, nenahraje se nic (je uzito implicitni nastaveni). }
procedure TMainForm.LoadConfiguration;
var
  iFileHandle, iFileLength, iBytesRead: Integer;
  bCounter1, bCounter2, bColor: Byte;
  bContainsNull: Boolean;
begin
  if not FileExists(SaveFileName) then
    Exit;

  { Otevreme soubor Nibbles.dat }
  iFileHandle := FileOpen(SaveFileName, fmOpenRead);
  if iFileHandle = (-1) then
    Exit;
  iFileLength := FileSeek(iFileHandle, 0, 2);

  { Kontrola velikosti tohoto souboru }
  if iFileLength <> SizeOf(DataToSave) then
  begin
    FileClose(iFileHandle);
    Exit;
  end;
  FileSeek(iFileHandle, 0, 0);

  { Nacteme data }
  iBytesRead := FileRead(iFileHandle, DataToSave, iFileLength);
  if iBytesRead <> iFileLength then
  begin
    FileClose(iFileHandle);
    Exit;
  end;

  { Zavreme soubor }
  FileClose(iFileHandle);

  { Zkontrolujeme nektera data ze souboru - test nespravnosti obsahu souboru }
  if (DataToSave.HighScores[0] >= 10000000) or
     (DataToSave.HighScores[1] >= 10000000) or
     (DataToSave.HighScores[2] >= 10000000) or
     (DataToSave.HighScores[3] >= 10000000) or
     (DataToSave.HighScores[4] >= 10000000) or
     (DataToSave.GameSpeed > 100) or
     (DataToSave.NibbleSettings[Blue].IQ > 10) or
     (DataToSave.NibbleSettings[Yellow].IQ > 10) or
     (DataToSave.NibbleSettings[Green].IQ > 10) or
     (DataToSave.NibbleSettings[Red].IQ > 10) then Exit;

  { Zjistime, jestli nazvy klaves a jmena v High score nactene ze souboru
    jsou skutecne retezce, tedy jestli obsahuji znak NULL. }
  for bColor := 0 to MaxColor do
    for bCounter1 := 0 to MaxPanel do
    begin
      bContainsNull := False;
      for bCounter2 := 0 to MaxKeyNameString do
        if DataToSave.NibbleSettings[bColor].KeyNames[bCounter1, bCounter2] = chr(0) then
          bContainsNull := True;
      if not bContainsNull then
        Exit;
    end;
  for bCounter1 := 0 to MaxHS do
  begin
    bContainsNull := False;
    for bCounter2 := 0 to MaxHSNameString do
      if DataToSave.HighScoreNames[bCounter1, bCounter2] = chr(0) then
        bContainsNull := True;
    if not bContainsNull then
      Exit;
  end;

  { A ted nastavime podle ziskanych dat prostredi, klavesy, High score apod. }
  for bColor := 0 to MaxColor do
  begin
    if DataToSave.NibbleSettings[bColor].Checked then
    begin
      NibbleInterface[bColor].CheckBox.Checked := True;
      NibbleInterface[bColor].KeySpeedButton.Enabled := True;
      NibbleInterface[bColor].HumSpeedButton.Enabled := True;
      NibbleInterface[bColor].CompSpeedButton.Enabled := True;
      NibbleInterface[bColor].IQTrackBar.Enabled := True;
    end;
    if DataToSave.NibbleSettings[bColor].IsHuman then
      NibbleInterface[bColor].HumSpeedButton.Down := True;
    if DataToSave.NibbleSettings[bColor].UsesTwoKeys then
    begin
      NibbleInterface[bColor].KeySpeedButton.Down := True;
      NibbleInterface[bColor].Panels[GoLeft].Visible := False;
      NibbleInterface[bColor].Panels[GoRight].Visible := False;
    end;
    for bCounter1 := 0 to MaxPanel do
      NibbleInterface[bColor].Panels[bCounter1].Caption := StrPas(DataToSave.NibbleSettings[bColor].KeyNames[bCounter1]);
    NibbleInterface[bColor].IQTrackBar.Position := DataToSave.NibbleSettings[bColor].IQ;
  end;

  for bCounter1 := 0 to MaxHS do
  begin
    HighScoreLabels[bCounter1].Name.Caption := StrPas(DataToSave.HighScoreNames[bCounter1]);
    HighScoreLabels[bCounter1].Score.Caption := IntToStr(DataToSave.HighScores[bCounter1]);
  end;

  GameSpeedTrackBar.Position := DataToSave.GameSpeed;

  if DataToSave.PlaySound then
    SoundCheckBox.Checked := true;

  { A prehrajeme pole s virtual key codes klaves ovladani }
  KeySettings := DataToSave.KeySettings;
end;


{ Tato procedura ulozi nastaveni ovladani a tabulku HighScore do souboru
  Nibbles.dat, pokud tento soubor neexistuje, bude vytvoren. }
procedure TMainForm.SaveConfiguration;
var
  iFileHandle, iBytesWritten: Integer;
  bColor: Byte;
  iCounter: Integer;
begin
  { Otevreme soubor Nibbles.dat, pokud neexistuje, bude vytvoren }
  if FileExists(SaveFileName) then
    iFileHandle := FileOpen(SaveFileName, fmOpenWrite)
  else
    iFileHandle := FileCreate(SaveFileName);
  if iFileHandle = (-1) then
    Exit;
  FileSeek(iFileHandle, 0, 0);

  { Vynulujeme cely rekord, aby zde nize u kazdeho ifu nemusel byt blok else }
  ZeroMemory(@DataToSave, SizeOf(DataToSave));

  { Preneseme ukladana data do recordu, ktery ulozime na disk jako celek }
  for bColor := 0 to MaxColor do
  begin
    if NibbleInterface[bColor].CheckBox.Checked then
      DataToSave.NibbleSettings[bColor].Checked := True;
    if NibbleInterface[bColor].HumSpeedButton.Down then
      DataToSave.NibbleSettings[bColor].IsHuman := True;
    if NibbleInterface[bColor].KeySpeedButton.Down then
      DataToSave.NibbleSettings[bColor].UsesTwoKeys := True;
    { Spolehame se, ze Captions nebudou delsi nez MaxKeyNameString znaku... }
    for iCounter := 0 to MaxPanel do
      StrPCopy(DataToSave.NibbleSettings[bColor].KeyNames[iCounter], NibbleInterface[bColor].Panels[iCounter].Caption);
    DataToSave.NibbleSettings[bColor].IQ := NibbleInterface[bColor].IQTrackBar.Position;
  end;

  DataToSave.GameSpeed := GameSpeedTrackBar.Position;
  DataToSave.PlaySound := SoundCheckBox.Checked;
  DataToSave.KeySettings := KeySettings;

  { Prepsani High Score }
  for iCounter := 0 to MaxHS do
  begin
    { Spolehame se, ze Captions nebudou delsi nez MaxHSNameString znaku... }
    StrPCopy(DataToSave.HighScoreNames[iCounter], HighScoreLabels[iCounter].Name.Caption);
    DataToSave.HighScores[iCounter] := StrToIntDef(HighScoreLabels[iCounter].Score.Caption, 0);
  end;

  { A data ulozime }
  iBytesWritten := FileWrite(iFileHandle, DataToSave, SizeOf(DataToSave));
  if iBytesWritten <> SizeOf(DataToSave) then
  begin
    { Pri ukladani nastala chyba, tak soubor vymazeme }
    FileClose(iFileHandle);
    DeleteFile(SaveFileName);
    Exit;
  end;
  { Zavreme soubor }
  FileClose(iFileHandle);
end;


{ Procedura provede nastaveni klaves pro hada bColor a panel bPanel,
  t.j. spusti KeyboardDialog a zkontroluje ostatni panely, jestli
  nemaji ulozenou stejnou klavesu. Vse osetri a vysledkem je nove
  nastaveni klaves. }
procedure TMainForm.SetKey(bColor, bPanel: Byte);
var
  strNewKeyString: string;    { Nazev nove uzivatelem definovane klavesy... }
  bNewKey: byte;              { ...a jeji cislo (virtual key code) }
  sDuplicateColor, sDuplicatePanel: Shortint; { Barva a cislo pripadneho panelu se stejnou klavesou }
  bColorCounter, bPanelCounter: Byte; { Pocitadla do for cyklu }
begin
  { Neni to chybka ? }
  if (bPanel > MaxPanel) or (bColor > MaxColor) then
    Exit;

  { Zmenime barvu panelu }
  NibbleInterface[bColor].Panels[bPanel].Color := clRed;

  { Inicializace }
  sDuplicateColor := -1;
  sDuplicatePanel := -1;

  { Spustime KeyboardDialog a zjistime, kterou klavesu uzivatel chce }
  bNewKey := KeyboardDialog( strNewKeyString );

  { Vybral vubec uzivatel nejakou klavesu ? }
  if bNewKey <> 0 then
  begin
    { Zjistime, ktery panel ma stejnou klavesu }
    for bColorCounter := 0 to MaxColor do
      for bPanelCounter := 0 to MaxPanel do
        if (KeySettings[bColorCounter, bPanelCounter] = bNewKey) then
        begin
          sDuplicateColor := bColorCounter;
          sDuplicatePanel := bPanelCounter;
        end;

    { Je tedy nejaka klavesa duplicitni ? }
    if sDuplicateColor <> (-1) then
    begin
      { Duplicitni klavesu "vynulujeme" }
      KeySettings[sDuplicateColor, sDuplicatePanel] := 0;
      NibbleInterface[sDuplicateColor].Panels[sDuplicatePanel].Caption := '';
    end;

    { Do panelu dame nazev klavesy }
    NibbleInterface[bColor].Panels[bPanel].Caption := strNewKeyString;

    { Ulozime virtual key code vybrane klavesy }
    KeySettings[bColor, bPanel] := bNewKey;
  end;

  { A nakonec obnovime barvu panelu }
  NibbleInterface[bColor].Panels[bPanel].Color := clSilver;
end;

{ Procedury nastavajici pri kliknuti na jeden z panelu nastaveni klaves,
  zmeni barvu panelu - good effect a zavolaji proceduru SetKey(), ta
  obstara zbytek. }
procedure TMainForm.BlueUpPanelClick(Sender: TObject);
begin
  SetKey(Blue, GoUp);
end;

procedure TMainForm.BlueDownPanelClick(Sender: TObject);
begin
  SetKey(Blue, GoDown);
end;

procedure TMainForm.BlueLeftPanelClick(Sender: TObject);
begin
  SetKey(Blue, GoLeft);
end;

procedure TMainForm.BlueRightPanelClick(Sender: TObject);
begin
  SetKey(Blue, GoRight);
end;

procedure TMainForm.YellowUpPanelClick(Sender: TObject);
begin
  SetKey(Yellow, GoUp);
end;

procedure TMainForm.YellowDownPanelClick(Sender: TObject);
begin
  SetKey(Yellow, GoDown);
end;

procedure TMainForm.YellowLeftPanelClick(Sender: TObject);
begin
  SetKey(Yellow, GoLeft);
end;

procedure TMainForm.YellowRightPanelClick(Sender: TObject);
begin
  SetKey(Yellow, GoRight);
end;

procedure TMainForm.GreenUpPanelClick(Sender: TObject);
begin
  SetKey(Green, GoUp);
end;

procedure TMainForm.GreenDownPanelClick(Sender: TObject);
begin
  SetKey(Green, GoDown);
end;

procedure TMainForm.GreenLeftPanelClick(Sender: TObject);
begin
  SetKey(Green, GoLeft);
end;

procedure TMainForm.GreenRightPanelClick(Sender: TObject);
begin
  SetKey(Green, GoRight);
end;

procedure TMainForm.RedUpPanelClick(Sender: TObject);
begin
  SetKey(Red, GoUp);
end;

procedure TMainForm.RedDownPanelClick(Sender: TObject);
begin
  SetKey(Red, GoDown);
end;

procedure TMainForm.RedLeftPanelClick(Sender: TObject);
begin
  SetKey(Red, GoLeft);
end;

procedure TMainForm.RedRightPanelClick(Sender: TObject);
begin
  SetKey(Red, GoRight);
end;

{ Tato procedura aktivuje/deaktivuje prvky interface hrace bColor }
procedure TMainForm.CheckBoxClick(bColor: Byte);
begin
  if NibbleInterface[bColor].CheckBox.Checked then
  begin
    NibbleInterface[bColor].KeySpeedButton.Enabled := True;
    NibbleInterface[bColor].HumSpeedButton.Enabled := True;
    NibbleInterface[bColor].CompSpeedButton.Enabled := True;
    NibbleInterface[bColor].IQTrackBar.Enabled := True;
  end
  else
  begin
    NibbleInterface[bColor].KeySpeedButton.Enabled := False;
    NibbleInterface[bColor].HumSpeedButton.Enabled := False;
    NibbleInterface[bColor].CompSpeedButton.Enabled := False;
    NibbleInterface[bColor].IQTrackBar.Enabled := False;
  end;
end;

{ Procedury pro aktivaci a deaktivaci SpeedButtonu podle stavu CheckBoxu. }
procedure TMainForm.BlueCheckBoxClick(Sender: TObject);
begin
  CheckBoxClick(Blue);
end;

procedure TMainForm.YellowCheckBoxClick(Sender: TObject);
begin
  CheckBoxClick(Yellow);
end;

procedure TMainForm.GreenCheckBoxClick(Sender: TObject);
begin
  CheckBoxClick(Green);
end;

procedure TMainForm.RedCheckBoxClick(Sender: TObject);
begin
  CheckBoxClick(Red);
end;

{ Procedura nastavajici pri stisknuti tlacitka 'Quit' }
procedure TMainForm.QuitButtonClick(Sender: TObject);
begin
  Close;
end;

{ Procedura nastavajici pri stisknuti tlacitka 'Help' }
procedure TMainForm.HelpButtonClick(Sender: TObject);
begin
  HelpForm.ShowModal;
end;

{ Procedura nastavajici pri stisknuti tlacitka 'Start game' }
procedure TMainForm.StartGameButtonClick(Sender: TObject);
begin
  { Hraje vubec nekdo ? }
  if not (RedCheckBox.Checked or YellowCheckBox.Checked or GreenCheckBox.Checked
          or BlueCheckBox.Checked) then
    Exit;
  { Aktivujeme GameForm }
  Hide;
  GameForm.ShowModal;
  Show;
end;

{ Procedura vypne/zapne nepotrebne panely pri 2/4-klavesovem ovladani }
procedure TMainForm.KeySpeedButtonClick(bColor: Byte);
begin
  if NibbleInterface[bColor].KeySpeedButton.Down then
  begin
    NibbleInterface[bColor].Panels[GoLeft].Visible := False;
    NibbleInterface[bColor].Panels[GoRight].Visible := False;
  end
  else
  begin
    NibbleInterface[bColor].Panels[GoLeft].Visible := True;
    NibbleInterface[bColor].Panels[GoRight].Visible := True;
  end;
end;


{ Pri 2-tlacitkovem ovladani se vypnou nepotrebne panely }
procedure TMainForm.BlueKeySpeedButtonClick(Sender: TObject);
begin
  KeySpeedButtonClick(Blue);
end;

procedure TMainForm.YellowKeySpeedButtonClick(Sender: TObject);
begin
  KeySpeedButtonClick(Yellow);
end;

procedure TMainForm.GreenKeySpeedButtonClick(Sender: TObject);
begin
  KeySpeedButtonClick(Green);
end;

procedure TMainForm.RedKeySpeedButtonClick(Sender: TObject);
begin
  KeySpeedButtonClick(Red);
end;

end.
